#include <wayland-client-protocol.h>
#include <gdk/wayland/gdkwayland.h>
#include "wayland.h"
#include "foreign.h"

static void handle_global(void *data, struct wl_registry *registry, uint32_t name, const gchar *interface, uint32_t version)
{
    /*if (!g_strcmp0(interface, zxdg_output_manager_v1_interface.name))
        xdg_output_register(registry, name);
    else if (!g_strcmp0(interface, wl_shm_interface.name))
        shm_register(registry, name);
    else if (!g_strcmp0(interface, zwlr_layer_shell_v1_interface.name))
        layer_shell_register(registry, name, version);
        if (!g_strcmp0(interface,zwlr_foreign_toplevel_manager_v1_interface.name))
    foreign_toplevel_register(registry,name);
        */
    //g_warning("register global: %s VS %s", interface, zwlr_foreign_toplevel_manager_v1_interface.name);
    (void) version;
    if (!g_strcmp0(interface, zwlr_foreign_toplevel_manager_v1_interface.name))
    {
        g_warning("register global: %s", interface);
        diya_shell_foreign_toplevel_register(registry, name, data);
    }
    
}

static void handle_global_remove(void *data, struct wl_registry *registry,
                                 uint32_t name)
{
    (void) data;
    (void) registry;
    (void) name;
}

static const struct wl_registry_listener registry_listener = {
    .global = handle_global,
    .global_remove = handle_global_remove
};

void diya_shell_wayland_init(DiyaShell *shell)
{
    struct wl_display *display;
    struct wl_registry *registry;
    display = gdk_wayland_display_get_wl_display(gdk_display_get_default());
    if (!display)
        g_error("Can't get wayland display\n");

    registry = wl_display_get_registry(display);
    wl_registry_add_listener(registry, &registry_listener, (void*)shell);
    wl_display_roundtrip(display);
    // wayland_monitor_probe();
    // GdkMonitor *mon = wayland_monitor_get_default();
    // g_info("default output: %s", (gchar *)g_object_get_data(G_OBJECT(mon), "xdg_name"));

    // wl_display_roundtrip(display);
    // wl_display_roundtrip(display);
}
